## emacs-pg-el 0.13+git.20130731.456516ec

=== debian/changelog ===
emacs-pg-el (0.13+git.20130731.456516ec-2) unstable; urgency=medium

  * Source-only upload.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 26 Jul 2020 14:29:58 -0700

emacs-pg-el (0.13+git.20130731.456516ec-1) unstable; urgency=low

  [ Matteo F. Vescovi & Sean Whitton ]
  * Initial release (Closes: #962816).

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 14 Jun 2020 09:09:26 -0700
