=== debian/control ===
Source: emacs-pg-el
Section: lisp
Priority: optional
Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
Uploaders:
 Matteo F. Vescovi <mfv@debian.org>,
 Sean Whitton <spwhitton@spwhitton.name>,
Build-Depends:
 debhelper-compat (= 12),
 dh-elpa,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/cbbrowne/pg.el
Vcs-Browser: https://salsa.debian.org/emacsen-team/emacs-pg-el
Vcs-Git: https://salsa.debian.org/emacsen-team/emacs-pg-el.git

Package: elpa-pg
Architecture: all
Depends:
 ${elpa:Depends},
 ${misc:Depends},
Recommends:
 emacs (>= 47.0),
Enhances:
 emacs,
 emacs25,
Built-Using:
 ${misc:Built-Using},
Description: Emacs Lisp interface for PostgreSQL
 This module lets you access the PostgreSQL object-relational DBMS from Emacs,
 using its socket-level frontend/backend protocol. The module is capable of
 automatic type coercions from a range of SQL types to the equivalent Emacs
 Lisp type.
 .
 This is a low level API, and won't be useful to end users.
