=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/emacs-pg-el-$1\.tar\.gz/ \
https://github.com/cbbrowne/pg.el/tags .*/v?(\d\S+)\.tar\.gz
