## emacs-pg-el 0.48

=== debian/changelog ===
emacs-pg-el (0.48-1) unstable; urgency=medium

  * New upstream release
  * Drop emacs25 from Enhances in d/control; no longer shipped since
    oldoldstable
  * Drop oldoldstable emacs version from Recommends in d/control
  * Update Standards-Version to 4.7.2; no change needed
  * Add patch to fix file mode of pg-geometry.el

 -- Xiyue Deng <manphiz@gmail.com>  Fri, 28 Feb 2025 01:48:54 -0800

emacs-pg-el (0.33-1) unstable; urgency=medium

  [ Sean Whitton ]
  * Remove myself from Uploaders.
  * Run 'wrap-and-sort -ast'.

  [ Xiyue Deng ]
  * Switch to new upstream at https://github.com/emarsden/pg-el (Closes:
    #1093398)
  * New upstream version
  * New maintainer (Closes: #1017880)
  * Update Homepage in d/control to track the new upstream
  * Update package description based on new upstream in d/control
  * Update d/watch to follow the new upstream
  * Update d/u/metadata with the new upstream info
  * Drop all patches as we are switching upstream
  * Drop d/s/{options,patch-header} now that patches are all dropped
  * Add d/gbp.conf matching the current practice
  * Update Standards-Version to 4.7.0; no change needed
  * Drop Built-Using from d/control
  * Update section to editors in d/control
  * Update copyright info for the new upstream in d/copyright
  * Add copyright info for doc/theme/highlight.js under BSD-3-Clause
  * Fix Sean's last name in d/copyright
  * Add d/docs to ship README.md
  * Add d/NEWS to announce switching to the new upstream
  * Add d/salsa-ci.yml with default template
  * Add doc/theme/highlight.js to d/missing-sources
  * Add lintian-overrides for highlight.js
    - The bundled highlight.js has higher version than the one available
      in Debian.
  * Add myself to debian/* clause in d/copyright
  * Update Standards-Version to 4.7.1; no change needed

 -- Xiyue Deng <manphiz@gmail.com>  Wed, 26 Feb 2025 13:27:53 -0800

emacs-pg-el (0.13+git.20130731.456516ec-3) unstable; urgency=medium

  * Team upload.
  * Rebuild against dh-elpa 2.1.5.
    Upload pushed to dgit-repos but not salsa.
    See <https://lists.debian.org/debian-emacsen/2024/07/msg00077.html>.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 25 Jul 2024 19:48:48 +0900
