## emacs-pg-el 0.49

=== debian/changelog ===
emacs-pg-el (0.49-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Sun, 09 Mar 2025 20:52:00 -0700
