## emacs-pg-el 0.51

=== debian/changelog ===
emacs-pg-el (0.51-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Mon, 31 Mar 2025 23:51:03 -0700

emacs-pg-el (0.50-1) unstable; urgency=medium

  * New upstream release
  * Drop 0001-Remove-executable-attribute-from-pg-geometry.el.patch
    - Applied upstream.

 -- Xiyue Deng <manphiz@gmail.com>  Wed, 26 Mar 2025 10:28:56 -0700
