## emacs-pg-el 0.52

=== debian/changelog ===
emacs-pg-el (0.52-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Wed, 09 Apr 2025 10:26:08 -0700
