## emacs-pg-el 0.53

=== debian/changelog ===
emacs-pg-el (0.53-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Tue, 22 Apr 2025 22:18:32 -0700
