## emacs-pg-el 0.54

=== test/Makefile ===
--- 
+++ 
@@ -58,24 +58,24 @@
 # Using Docker images for Emacs from https://hub.docker.com/r/silex/emacs/ and the locally installed
 # PostgreSQL.
 test-emacs-dev: test-pg.el
-	cp install-deps.el load-deps.el ../pg.el ../pg-geometry.el ../pg-gis.el test-pg.el ${WORKDIR}
+	cp install-deps.el load-deps.el ../pg.el ../pg-geometry.el ../pg-gis.el ../pg-bm25.el test-pg.el ${WORKDIR}
 	${DOCKER} run --rm -it \
 	   -v ${WORKDIR}:/tmp \
 	   -e DEPS_DIR=/tmp/deps \
 	   -e PGEL_HOSTNAME=10.0.2.2 \
 	   --network slirp4netns:allow_host_loopback=true \
 	   docker.io/silex/emacs:master-alpine-ci \
-	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l ../tmp/pg-geometry.el -l /tmp/pg-gis.el -l /tmp/test-pg.el -f pg-test
+	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l ../tmp/pg-geometry.el -l /tmp/pg-gis.el -l /tmp/pg-bm25.el -l /tmp/test-pg.el -f pg-test
 
 test-emacs28: test-pg.el
-	cp install-deps.el load-deps.el ../pg.el ../pg-geometry.el ../pg-gis.el test-pg.el ${WORKDIR}
+	cp install-deps.el load-deps.el ../pg.el ../pg-geometry.el ../pg-gis.el ../pg-bm25.el test-pg.el ${WORKDIR}
 	${DOCKER} run --rm -it \
 	   -v ${WORKDIR}:/tmp \
 	   -e DEPS_DIR=/tmp/deps \
 	   -e PGEL_HOSTNAME=10.0.2.2 \
 	   --network slirp4netns:allow_host_loopback=true \
 	   docker.io/silex/emacs:28.1 \
-	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l /tmp/pg-geometry.el -l /tmp/pg-gis.el -l /tmp/test-pg.el -f pg-test
+	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l /tmp/pg-geometry.el -l /tmp/pg-gis.el -l /tmp/pg-bm25.el -l /tmp/test-pg.el -f pg-test
 
 # The peg.el library doesn't actually compile with Emacs 27 (void-function byte-run--set-speed), so
 # this doesn't work.
@@ -299,4 +299,3 @@
 	   -e POSTGRESQL_PGHBA_REMOVE_FILTERS=local,md5,trust \
 	   -d docker.io/bitnami/postgresql:latest
 	sleep 5
-	PGEL_CLIENT_CERT=${WORKDIR}/client.crt PGEL_CLIENT_CERT_KEY=${WORKDIR}/client.key PGEL_PORT=5488 ${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-client-cert
