=== debian/changelog ===
emacs-pg-el (0.54-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Sun, 04 May 2025 21:45:50 -0700
