=== debian/control ===
Source: emacs-pg-el
Section: editors
Priority: optional
Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
Uploaders:
 Matteo F. Vescovi <mfv@debian.org>,
 Xiyue Deng <manphiz@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 dh-elpa,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/emacsen-team/emacs-pg-el
Vcs-Git: https://salsa.debian.org/emacsen-team/emacs-pg-el.git
Homepage: https://github.com/emarsden/pg-el
Rules-Requires-Root: no

Package: elpa-pg
Architecture: all
Depends:
 ${elpa:Depends},
 ${misc:Depends},
Recommends:
 emacs,
Enhances:
 emacs,
Description: pg.el -- Emacs Lisp socket-level interface to the PostgreSQL RDBMS
 This module lets you access the PostgreSQL object-relational DBMS
 from Emacs, using its socket-level frontend/backend protocol. The
 module is capable of automatic type coercions from a range of SQL
 types to the equivalent Emacs Lisp type.
 .
 Supported features:
 .
  - SCRAM-SHA-256 authentication (the default method since PostgreSQL
    version 14) and MD5 authentication.
 .
  - Encrypted (TLS) connections between Emacs and the PostgreSQL
    backend.
 .
  - Support for the SQL COPY protocol to copy preformatted data to
    PostgreSQL from an Emacs buffer.
 .
  - Asynchronous handling of LISTEN/NOTIFY notification messages from
    PostgreSQL, allowing the implementation of publish-subscribe type
    architectures (PostgreSQL as an "event broker" or "message bus"
    and Emacs as event publisher and consumer).
 .
  - Support for PostgreSQL's extended query syntax, that allows for
    parameterized queries to protect from SQL injection issues.
 .
 This is a low level API, and won't be useful to end users. If you're
 looking for a browsing/editing interface to PostgreSQL, see the
 PGmacs module from https://github.com/emarsden/pgmacs/.
