## emacs-pg-el 0.58

=== debian/changelog ===
emacs-pg-el (0.58-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Thu, 14 Aug 2025 22:07:15 -0700
