## emacs-pg-el 0.59

=== test/Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 test: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el ../pg.el \
-	   -l pg.el -l pg-geometry.el -l pg-gis.el -l test-pg.el -f pg-test
+	   -l pg.el -l pg-geometry.el -l pg-gis.el -l pg-lo.el -l test-pg.el -f pg-test
 
 test-interactive: test-pg.el install-deps
 	${EMACS} -Q -L .. -L . -l load-deps.el ../pg.el \
@@ -33,6 +33,7 @@
 test-tls: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-tls
 
+# This needs Emacs support for ALPN (currently unimplemented).
 test-tls-direct: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-tls-direct
 
@@ -116,19 +117,6 @@
 	   docker.io/silex/emacs:25.3 \
 	   ${EMACS} -Q --batch /tmp/pg.el -l /tmp/install-deps.el -l /tmp/load-deps.el -l /tmp/pg.el -l /tmp/test-pg.el -f pg-test
 
-test-postgresql17: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5426:5426 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5426 \
-	   -e TZ=Asia/Tokyo \
-	   -d docker.io/library/postgres:17-alpine
-	sleep 5
-	PGEL_PORT=5426 $(MAKE) test
-	${DOCKER} stop pgsql
-
 # A special test for short usernames, database names, passwords and so on (we used to have some
 # builtin assumptions that a username was a least 4 chars in length).
 test-shortnames: test-pg.el
@@ -143,125 +131,12 @@
 	PGEL_PORT=5926 PGEL_DATABASE=d PGEL_USER=u PGEL_PASSWORD="~" $(MAKE) test
 	${DOCKER} stop pgsql
 
-test-postgresql16: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5416:5416 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5416 \
-	   -e TZ=Asia/Tokyo \
-	   -d docker.io/library/postgres:16-alpine
-	sleep 5
-	TZ=Asia/Tokyo PGEL_PORT=5416 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql15: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5116:5116 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5116 \
-	   -d docker.io/library/postgres:15
-	sleep 5
-	PGEL_PORT=5116 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql14: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5439:5439 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5439 \
-	   -d docker.io/library/postgres:14
-	sleep 5
-	PGEL_PORT=5439 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql13: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5439:5439 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5439 \
-	   -d docker.io/library/postgres:13-alpine
-	sleep 5
-	PGEL_PORT=5439 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql12: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5439:5439 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5439 \
-	   -d docker.io/library/postgres:12-alpine
-	sleep 5
-	PGEL_PORT=5439 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql11: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-	   --publish 5437:5437 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5437 \
-	   -d docker.io/library/postgres:11-alpine
-	sleep 5
-	PGEL_PORT=5437 $(MAKE) test
-	${DOCKER} stop pgsql
-
-
-# EDB with a Red Hat Universal Base Image. This defaults to an SQL_ASCII client-encoding unless we
-# set LC_CTYPE.
+# Note that we need to tell Emacs GnuTLS to trust the root.crt file in order for it to accept the
+# PostgreSQL server TLS certificate (it's not signed by the system CA).
 #
-# https://github.com/EnterpriseDB/docker-postgresql
-test-enterprisedb: test-pg.el
-	${DOCKER} run --rm --name edb \
-	   --publish 5366:5366 \
-	   -e TZ=UTC-7:00 \
-	   -e LANG=en_US.UTF8 \
-	   -e LC_CTYPE=en_US.UTF8 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5366 \
-	   -d ghcr.io/enterprisedb/postgresql:17
-	TZ=UTC-7:00 PGEL_PORT=5366 $(MAKE) test
-	${DOCKER} stop edb
-
-
-# Tests with a PostgreSQL server configured to only accept clients that present a CA-signed certificate.
-#
-#   https://www.postgresql.org/docs/current/ssl-tcp.html
-#
-# We use openssl to generate a new Root certificate authority and key. Use the root CA to create a
-# server certificate and key and a client certificate and key. Start PostgreSQL with the server
-# certificate and the root CA certificate, configured to require clients to present a client
-# certificate signed by our root CA. Connect presenting the client certificate (this uses the GnuTLS
-# support for client certificates in Emacs).
-#
-# Note: mounting the pgcerts volume with the :U modifier maps the file owner for all volume files to
-# that selected by the container ("postgres"), which is required for PostgreSQL to accept that the
-# server certificate key is not readable by other users.
-#
-# https://github.com/bitnami/containers/blob/main/bitnami/postgresql/README.md
-#
-# The Bitnami configuration for pg_hba.conf deletes all lines with authentication methods
-# local, or md5, or trust (our value for POSTGRESQL_PHHBA_REMOVE_FILTERS), and adds a line
-#
-#   hostssl     all             all             0.0.0.0/0               cert
-#
-# This means the equivalent of clientcert=verify-full, meaning that the server will verify that the
-# client certificate is signed by its root CA (configured as /certs/root.crt below) and will also
-# verify that the username specified in the CN field of the certificate corresponds to the
-# PostgreSQL username we are connecting as.
-test-certificates: test-pg.el install-deps
+# Currently failing with Emacs 31.0.50 with
+#   LOG:  received direct SSL connection request without ALPN protocol negotiation extension
+test-postgresql18betatls: test-pg.el
 	openssl req -new -nodes -text -out ${WORKDIR}/root.csr -keyout ${WORKDIR}/root.key \
 	   -subj "/CN=localhost"
 	chmod og-rwx ${WORKDIR}/root.key
@@ -285,17 +160,167 @@
 	${DOCKER} volume create pgcerts
 	tar cf ${WORKDIR}/certs.tar --directory=${WORKDIR} server.crt server.key root.crt
 	${DOCKER} volume import pgcerts ${WORKDIR}/certs.tar
-	${DOCKER} run --rm --name pgsqltls \
-	   -v pgcerts:/certs:U \
-	   --publish 5488:5488 \
-	   -e POSTGRESQL_PORT_NUMBER=5488 \
-	   -e POSTGRESQL_DATABASE=pgeltestdb \
-	   -e POSTGRESQL_USERNAME=pgeltestuser \
-	   -e POSTGRESQL_PASSWORD=pgeltest \
-	   -e POSTGRESQL_ENABLE_TLS=yes \
-	   -e POSTGRESQL_TLS_CERT_FILE=/certs/server.crt \
-	   -e POSTGRESQL_TLS_KEY_FILE=/certs/server.key \
-	   -e POSTGRESQL_TLS_CA_FILE=/certs/root.crt \
-	   -e POSTGRESQL_PGHBA_REMOVE_FILTERS=local,md5,trust \
-	   -d docker.io/bitnami/postgresql:latest
-	sleep 5
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+           -v pgcerts:/certs:U \
+           --publish 5418:5418 \
+           -e POSTGRES_DB=pgeltestdb \
+           -e POSTGRES_USER=pgeltestuser \
+           -e POSTGRES_PASSWORD=pgeltest \
+           -e PGPORT=5418 \
+           -e TZ=Asia/Tokyo \
+           --user postgres \
+           -d docker.io/library/postgres:18beta3-alpine \
+              -c ssl=on \
+              -c ssl_cert_file=/certs/server.crt \
+              -c ssl_key_file=/certs/server.key
+	sleep 5
+	PGEL_TRUST_CA=${WORKDIR}/root.crt PGEL_PORT=5418 $(MAKE) test-tls-direct
+	${DOCKER} stop pgsql
+	sleep 2
+	${DOCKER} volume rm pgcerts
+
+
+test-postgresql18beta: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5418:5418 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5418 \
+	   -e TZ=Asia/Tokyo \
+	   -d docker.io/library/postgres:18beta3-alpine
+	sleep 5
+	PGEL_PORT=5418 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql18: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5418:5418 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5418 \
+	   -e TZ=Asia/Tokyo \
+	   -d docker.io/library/postgres:18-alpine
+	sleep 5
+	PGEL_PORT=5418 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql17: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5426:5426 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5426 \
+	   -e TZ=Asia/Tokyo \
+	   -d docker.io/library/postgres:17-alpine
+	sleep 5
+	PGEL_PORT=5426 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql16: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5416:5416 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5416 \
+	   -e TZ=Asia/Tokyo \
+	   -d docker.io/library/postgres:16-alpine
+	sleep 5
+	TZ=Asia/Tokyo PGEL_PORT=5416 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql15: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5116:5116 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5116 \
+	   -d docker.io/library/postgres:15
+	sleep 5
+	PGEL_PORT=5116 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql14: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+           --pull=newer \
+	   --publish 5439:5439 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5439 \
+	   -d docker.io/library/postgres:14
+	sleep 5
+	PGEL_PORT=5439 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql13: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+	   --publish 5439:5439 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5439 \
+	   -d docker.io/library/postgres:13-alpine
+	sleep 5
+	PGEL_PORT=5439 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql12: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+	   --publish 5439:5439 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5439 \
+	   -d docker.io/library/postgres:12-alpine
+	sleep 5
+	PGEL_PORT=5439 $(MAKE) test
+	${DOCKER} stop pgsql
+
+test-postgresql11: test-pg.el
+	${DOCKER} run --rm --name pgsql \
+	   --publish 5437:5437 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5437 \
+	   -d docker.io/library/postgres:11-alpine
+	sleep 5
+	PGEL_PORT=5437 $(MAKE) test
+	${DOCKER} stop pgsql
+
+
+# EDB with a Red Hat Universal Base Image. This defaults to an SQL_ASCII client-encoding unless we
+# set LC_CTYPE.
+#
+# https://github.com/EnterpriseDB/docker-postgresql
+test-enterprisedb: test-pg.el
+	${DOCKER} run --rm --name edb \
+	   --publish 5366:5366 \
+	   -e TZ=UTC-7:00 \
+	   -e LANG=en_US.UTF8 \
+	   -e LC_CTYPE=en_US.UTF8 \
+	   -e POSTGRES_DB=pgeltestdb \
+	   -e POSTGRES_USER=pgeltestuser \
+	   -e POSTGRES_PASSWORD=pgeltest \
+	   -e PGPORT=5366 \
+	   -d ghcr.io/enterprisedb/postgresql:17
+	TZ=UTC-7:00 PGEL_PORT=5366 $(MAKE) test
+	${DOCKER} stop edb
+
+
+# Tests with a PostgreSQL server configured to only accept clients that present a CA-signed certificate.
+#
+#   https://www.postgresql.org/docs/current/ssl-tcp.html
+#
+# We use openssl to generate a new Root certificate authority and key. Use the root CA to create a
