## emacs-pg-el 0.60

=== test/Makefile ===
--- 
+++ 
@@ -33,7 +33,7 @@
 test-tls: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-tls
 
-# This needs Emacs support for ALPN (currently unimplemented).
+# This needs Emacs support for ALPN (currently under development).
 test-tls-direct: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-test-tls-direct
 
@@ -49,8 +49,11 @@
 test-connections: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pg.el -f pg-connection-tests
 
-test-multithreaded: test-pg.el install-deps
+test-multithreaded: test-multithreaded.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-multithreaded.el -f pgtest-multithreaded
+
+test-async: test-async.el install-deps
+	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-async.el -f pgtest-async
 
 test-pgvector: test-pgvector.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el -l ../pg.el -l test-pgvector.el -f pg-test
@@ -130,6 +133,7 @@
 	sleep 5
 	PGEL_PORT=5926 PGEL_DATABASE=d PGEL_USER=u PGEL_PASSWORD="~" $(MAKE) test
 	${DOCKER} stop pgsql
+
 
 # Note that we need to tell Emacs GnuTLS to trust the root.crt file in order for it to accept the
 # PostgreSQL server TLS certificate (it's not signed by the system CA).
@@ -181,7 +185,7 @@
 	${DOCKER} volume rm pgcerts
 
 
-test-postgresql18beta: test-pg.el
+test-postgresql18: test-pg.el
 	${DOCKER} run --rm --name pgsql \
            --pull=newer \
 	   --publish 5418:5418 \
@@ -190,21 +194,7 @@
 	   -e POSTGRES_PASSWORD=pgeltest \
 	   -e PGPORT=5418 \
 	   -e TZ=Asia/Tokyo \
-	   -d docker.io/library/postgres:18beta3-alpine
-	sleep 5
-	PGEL_PORT=5418 $(MAKE) test
-	${DOCKER} stop pgsql
-
-test-postgresql18: test-pg.el
-	${DOCKER} run --rm --name pgsql \
-           --pull=newer \
-	   --publish 5418:5418 \
-	   -e POSTGRES_DB=pgeltestdb \
-	   -e POSTGRES_USER=pgeltestuser \
-	   -e POSTGRES_PASSWORD=pgeltest \
-	   -e PGPORT=5418 \
-	   -e TZ=Asia/Tokyo \
-	   -d docker.io/library/postgres:18-alpine
+	   -d docker.io/library/postgres:18rc1-alpine
 	sleep 5
 	PGEL_PORT=5418 $(MAKE) test
 	${DOCKER} stop pgsql
@@ -324,3 +314,5 @@
 #   https://www.postgresql.org/docs/current/ssl-tcp.html
 #
 # We use openssl to generate a new Root certificate authority and key. Use the root CA to create a
+# server certificate and key and a client certificate and key. Start PostgreSQL with the server
+# certificate and the root CA certificate, configured to require clients to present a client
