=== debian/changelog ===
emacs-pg-el (0.60-1) unstable; urgency=medium

  * New upstream release
  * Drop "Rules-Requires-Root" from d/control
    - This is now the default.

 -- Xiyue Deng <manphiz@gmail.com>  Thu, 25 Sep 2025 22:54:23 -0700
