=== debian/control ===
--- 
+++ 
@@ -12,7 +12,6 @@
 Vcs-Browser: https://salsa.debian.org/emacsen-team/emacs-pg-el
 Vcs-Git: https://salsa.debian.org/emacsen-team/emacs-pg-el.git
 Homepage: https://github.com/emarsden/pg-el
-Rules-Requires-Root: no
 
 Package: elpa-pg
 Architecture: all
