=== debian/changelog ===
emacs-pg-el (0.61-1) unstable; urgency=medium

  * New upstream release

 -- Xiyue Deng <manphiz@gmail.com>  Wed, 26 Nov 2025 15:17:37 -0800
