## emacs-pg-el 0.62

=== test/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 WORKDIR := $(shell mktemp -d)
 
 # export DEPS_DIR = $(shell realpath .deps)
-export DEPS_DIR := $(shell mktemp -d --tmpdir emacsdepsXXXX)
+export DEPS_DIR := $(shell mktemp -d -t emacsdepsXXXX)
 
 default: test
 
@@ -16,6 +16,7 @@
 test: test-pg.el install-deps
 	${EMACS} -Q --batch -L .. -L . -l load-deps.el ../pg.el \
 	   -l pg.el -l pg-geometry.el -l pg-gis.el -l pg-lo.el -l test-pg.el -f pg-test
+	rm -r ${DEPS_DIR}
 
 test-interactive: test-pg.el install-deps
 	${EMACS} -Q -L .. -L . -l load-deps.el ../pg.el \
