=== debian/changelog ===
emacs-pg-el (0.62-1) unstable; urgency=medium

  * New upstream release
  * Update Standards-Version to 4.7.3; no change needed
  * Drop `Priority: optional'; now default

 -- Xiyue Deng <manphiz@gmail.com>  Wed, 31 Dec 2025 04:57:43 -0800
