=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: emacs-pg-el
 Section: editors
-Priority: optional
 Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
 Uploaders:
  Matteo F. Vescovi <mfv@debian.org>,
@@ -8,7 +7,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-elpa,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/emacsen-team/emacs-pg-el
 Vcs-Git: https://salsa.debian.org/emacsen-team/emacs-pg-el.git
 Homepage: https://github.com/emarsden/pg-el
