## emacs-pg-el 0.63

=== test/Makefile ===
--- 
+++ 
@@ -297,6 +297,7 @@
 # https://github.com/EnterpriseDB/docker-postgresql
 test-enterprisedb: test-pg.el
 	${DOCKER} run --rm --name edb \
+           --pull=newer \
 	   --publish 5366:5366 \
 	   -e TZ=UTC-7:00 \
 	   -e LANG=en_US.UTF8 \
