=== debian/changelog ===
emacs-pg-el (0.63-1) unstable; urgency=medium

  * New upstream release
  * Update my Debian copyright year in d/copyright

 -- Xiyue Deng <manphiz@gmail.com>  Sun, 15 Feb 2026 03:58:54 -0800
